# -*- coding: utf-8 -*-
# Generated by Django 1.9.2 on 2016-02-16 21:54
from __future__ import unicode_literals

from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        ('contenttypes', '0002_remove_content_type_name'),
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
    ]

    operations = [
        migrations.CreateModel(
            name='Company',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=200, verbose_name='name')),
                ('nickname', models.CharField(blank=True, max_length=50, null=True, verbose_name='nickname')),
                ('slug', models.SlugField(unique=True, verbose_name='slug')),
                ('about', models.TextField(blank=True, null=True, verbose_name='about')),
                ('logo', models.ImageField(blank=True, upload_to='contacts/companies/', verbose_name='photo')),
                ('date_added', models.DateTimeField(auto_now_add=True, verbose_name='date added')),
                ('date_modified', models.DateTimeField(auto_now=True, verbose_name='date modified')),
            ],
            options={
                'verbose_name_plural': 'companies',
                'db_table': 'contacts_companies',
                'verbose_name': 'company',
                'ordering': ('name',),
            },
        ),
        migrations.CreateModel(
            name='EmailAddress',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('object_id', models.IntegerField(db_index=True)),
                ('email_address', models.EmailField(max_length=254, verbose_name='email address')),
                ('date_added', models.DateTimeField(auto_now_add=True, verbose_name='date added')),
                ('date_modified', models.DateTimeField(auto_now=True, verbose_name='date modified')),
                ('content_type', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='contenttypes.ContentType')),
            ],
            options={
                'db_table': 'contacts_email_addresses',
                'verbose_name': 'email address',
                'verbose_name_plural': 'email addresses',
            },
        ),
        migrations.CreateModel(
            name='Group',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=200, verbose_name='name')),
                ('slug', models.SlugField(unique=True, verbose_name='slug')),
                ('about', models.TextField(blank=True, verbose_name='about')),
                ('date_added', models.DateTimeField(auto_now_add=True, verbose_name='date added')),
                ('date_modified', models.DateTimeField(auto_now=True, verbose_name='date modified')),
                ('companies', models.ManyToManyField(blank=True, to='contacts.Company', verbose_name='companies')),
            ],
            options={
                'verbose_name_plural': 'groups',
                'db_table': 'contacts_groups',
                'verbose_name': 'group',
                'ordering': ('name',),
            },
        ),
        migrations.CreateModel(
            name='InstantMessenger',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('object_id', models.IntegerField(db_index=True)),
                ('im_account', models.CharField(max_length=100, verbose_name='im account')),
                ('service', models.CharField(choices=[('aim', 'AIM'), ('msn', 'MSN'), ('icq', 'ICQ'), ('jabber', 'Jabber'), ('yahoo', 'Yahoo'), ('skype', 'Skype'), ('qq', 'QQ'), ('sametime', 'Sametime'), ('gadu-gadu', 'Gadu-Gadu'), ('google-talk', 'Google Talk'), ('other', 'Other')], default='other', max_length=11, verbose_name='service')),
                ('date_added', models.DateTimeField(auto_now_add=True, verbose_name='date added')),
                ('date_modified', models.DateTimeField(auto_now=True, verbose_name='date modified')),
                ('content_type', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='contenttypes.ContentType')),
            ],
            options={
                'db_table': 'contacts_instant_messengers',
                'verbose_name': 'instant messenger',
                'verbose_name_plural': 'instant messengers',
            },
        ),
        migrations.CreateModel(
            name='Location',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=200, verbose_name='name')),
                ('slug', models.SlugField(unique=True, verbose_name='slug')),
                ('is_phone', models.BooleanField(default=False, help_text='Only used for Phone', verbose_name='is phone')),
                ('is_street_address', models.BooleanField(default=False, help_text='Only used for Street Address', verbose_name='is street address')),
                ('weight', models.IntegerField(choices=[(0, 0), (1, 1), (2, 2), (3, 3), (4, 4), (5, 5), (6, 6), (7, 7), (8, 8), (9, 9), (10, 10)], default=0)),
                ('date_added', models.DateTimeField(auto_now_add=True, verbose_name='date added')),
                ('date_modified', models.DateTimeField(auto_now=True, verbose_name='date modified')),
            ],
            options={
                'verbose_name_plural': 'locations',
                'db_table': 'contacts_locations',
                'verbose_name': 'location',
                'ordering': ('weight',),
            },
        ),
        migrations.CreateModel(
            name='Person',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('first_name', models.CharField(max_length=100, verbose_name='first name')),
                ('last_name', models.CharField(max_length=200, verbose_name='last name')),
                ('middle_name', models.CharField(blank=True, max_length=200, null=True, verbose_name='middle name')),
                ('suffix', models.CharField(blank=True, max_length=50, null=True, verbose_name='suffix')),
                ('nickname', models.CharField(blank=True, max_length=100, verbose_name='nickname')),
                ('slug', models.SlugField(unique=True, verbose_name='slug')),
                ('title', models.CharField(blank=True, max_length=200, verbose_name='title')),
                ('about', models.TextField(blank=True, verbose_name='about')),
                ('photo', models.ImageField(blank=True, upload_to='contacts/person/', verbose_name='photo')),
                ('date_added', models.DateTimeField(auto_now_add=True, verbose_name='date added')),
                ('date_modified', models.DateTimeField(auto_now=True, verbose_name='date modified')),
                ('company', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='contacts.Company')),
                ('user', models.OneToOneField(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL, verbose_name='user')),
            ],
            options={
                'verbose_name_plural': 'people',
                'db_table': 'contacts_people',
                'verbose_name': 'person',
                'ordering': ('last_name', 'first_name'),
            },
        ),
        migrations.CreateModel(
            name='PhoneNumber',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('object_id', models.IntegerField(db_index=True)),
                ('phone_number', models.CharField(max_length=50, verbose_name='number')),
                ('date_added', models.DateTimeField(auto_now_add=True, verbose_name='date added')),
                ('date_modified', models.DateTimeField(auto_now=True, verbose_name='date modified')),
                ('content_type', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='contenttypes.ContentType')),
                ('location', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='contacts.Location')),
            ],
            options={
                'db_table': 'contacts_phone_numbers',
                'verbose_name': 'phone number',
                'verbose_name_plural': 'phone numbers',
            },
        ),
        migrations.CreateModel(
            name='SpecialDate',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('object_id', models.IntegerField(db_index=True)),
                ('occasion', models.TextField(max_length=200, verbose_name='occasion')),
                ('date', models.DateField(verbose_name='date')),
                ('every_year', models.BooleanField(default=True, verbose_name='every year')),
                ('date_added', models.DateTimeField(auto_now_add=True, verbose_name='date added')),
                ('date_modified', models.DateTimeField(auto_now=True, verbose_name='date modified')),
                ('content_type', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='contenttypes.ContentType')),
            ],
            options={
                'db_table': 'contacts_special_dates',
                'verbose_name': 'special date',
                'verbose_name_plural': 'special dates',
            },
        ),
        migrations.CreateModel(
            name='StreetAddress',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('object_id', models.IntegerField(db_index=True)),
                ('street', models.TextField(blank=True, verbose_name='street')),
                ('city', models.CharField(blank=True, max_length=200, verbose_name='city')),
                ('province', models.CharField(blank=True, max_length=200, verbose_name='province')),
                ('postal_code', models.CharField(blank=True, max_length=10, verbose_name='postal code')),
                ('country', models.CharField(max_length=100, verbose_name='country')),
                ('date_added', models.DateTimeField(auto_now_add=True, verbose_name='date added')),
                ('date_modified', models.DateTimeField(auto_now=True, verbose_name='date modified')),
                ('content_type', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='contenttypes.ContentType')),
                ('location', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='contacts.Location')),
            ],
            options={
                'db_table': 'contacts_street_addresses',
                'verbose_name': 'street address',
                'verbose_name_plural': 'street addresses',
            },
        ),
        migrations.CreateModel(
            name='WebSite',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('object_id', models.IntegerField(db_index=True)),
                ('url', models.URLField(verbose_name='URL')),
                ('date_added', models.DateTimeField(auto_now_add=True, verbose_name='date added')),
                ('date_modified', models.DateTimeField(auto_now=True, verbose_name='date modified')),
                ('content_type', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='contenttypes.ContentType')),
                ('location', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='contacts.Location')),
            ],
            options={
                'db_table': 'contacts_web_sites',
                'verbose_name': 'web site',
                'verbose_name_plural': 'web sites',
            },
        ),
        migrations.AddField(
            model_name='instantmessenger',
            name='location',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='contacts.Location'),
        ),
        migrations.AddField(
            model_name='group',
            name='people',
            field=models.ManyToManyField(blank=True, to='contacts.Person', verbose_name='people'),
        ),
        migrations.AddField(
            model_name='emailaddress',
            name='location',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='contacts.Location'),
        ),
    ]
